import org.junit.jupiter.api.Assertions.assertArrayEquals
import org.junit.jupiter.api.Test
import kotlin.test.assertEquals
import kotlin.test.assertTrue

val colors = mapOf("verd" to "\u001B[48;2;60;168;63m\u001B[1m\u001B[38;2;255;255;255m",
    "gris" to "\u001b[48;2;120;124;126m\u001B[1m\u001B[38;2;255;255;255m",
    "groc" to "\u001b[48;2;214;154;41m\u001B[1m\u001B[38;2;255;255;255m",
    "reset" to "\u001b[0m", "Lvermell" to "\u001b[38;2;255;0;0m",
    "negreFons" to "\u001b[48;2;0;0;0m\u001B[1m\u001B[38;2;255;255;255m",
    "grisClar" to "\u001b[0m\u001b[48;2;211;214;218m\u001B[38;5;0m",
    "negre" to "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m",
    "blanc" to "\u001B[48;2;255;255;255m\u001B[1m\u001B[38;2;0;0;0m")
val missatges = listOf<String>("m1", "m2", "m3", "m4", "m5", "m6", "m7", "m8", "m9", "m10", "m11", "m12", "m13", "m14", "m15",)
internal class UtilitatsTest {

    //Tests funció preguntarTornarAJugar
    @Test
    fun testLlistaBuida(){
        assertEquals("n", preguntarTornarAJugar(paraules = mutableListOf(), missatges))
    }

    //Tests funció reiniciarTeclat
    @Test
    fun testReiniciarTeclat(){
        var teclat = arrayOf(" Q ", " W ", " E ", " R ", " T ", " Y ", " U ", " I ", " O ", " P ", " A ", " S ", " D ", " F ", " G ", " H ", " J ", " K ", " L ", " Ç ", " Z ", " X ", " C ", " V ", " B ", " N ", " M ")
        val teclat2 = arrayOf("\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Q ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m W ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m E ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m R ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m T ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Y ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m U ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m I ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m O ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m P ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m A ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m S ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m D ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m F ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m G ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m H ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m J ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m K ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m L ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Ç ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Z ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m X ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m C ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m V ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m B ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m N ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m M ")
        assertArrayEquals(teclat2, reiniciarTeclat(teclat))
    }

    //Tests funció comprovarParaula
    @Test
    fun testLletresRepetides(){
        val intents=0
        var teclat1 = arrayOf(arrayOf("\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Q ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m W ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m E ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m R ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m T ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Y ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m U ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m I ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m O ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m P ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m A ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m S ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m D ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m F ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m G ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m H ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m J ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m K ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m L ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Ç ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Z ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m X ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m C ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m V ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m B ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m N ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m M "))
        var jugada1= Array(6){Array(5){"\u001b[1m\u001b[38;5;0m\u001b[48;2;255;255;255m - "} }
        var jugadaTeclat= Pair(teclat1, jugada1)
        val respostaJugada= arrayOf("\u001B[48;2;120;124;126m\u001B[1m\u001B[38;2;255;255;255m A ", "\u001B[48;2;214;154;41m\u001B[1m\u001B[38;2;255;255;255m C ", "\u001B[48;2;120;124;126m\u001B[1m\u001B[38;2;255;255;255m A ", "\u001B[48;2;120;124;126m\u001B[1m\u001B[38;2;255;255;255m B ", "\u001B[48;2;60;168;63m\u001B[1m\u001B[38;2;255;255;255m A ")
        val respostaTeclat= arrayOf("\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Q ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m W ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m E ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m R ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m T ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Y ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m U ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m I ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m O ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m P ", "\u001B[48;2;60;168;63m\u001B[1m\u001B[38;2;255;255;255m A ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m S ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m D ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m F ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m G ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m H ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m J ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m K ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m L ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Ç ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Z ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m X ", "\u001B[48;2;214;154;41m\u001B[1m\u001B[38;2;255;255;255m C ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m V ", "\u001B[48;2;120;124;126m\u001B[1m\u001B[38;2;255;255;255m B ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m N ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m M ")
        val (teclat, jugada) = comprovarParaula(paraula = "COSTA", intent = "ACABA", intents, jugadaTeclat)
        assertArrayEquals(respostaJugada, jugada[intents])
        assertArrayEquals(respostaTeclat, teclat[0])
    }

    //Tests funció canviarColorLletraTeclat
    @Test
    fun testLletraVerda(){
        var teclat=arrayOf("\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Q ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m W ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m E ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m R ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m T ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Y ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m U ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m I ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m O ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m P ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m A ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m S ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m D ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m F ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m G ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m H ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m J ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m K ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m L ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Ç ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Z ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m X ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m C ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m V ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m B ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m N ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m M ")
        var teclat2= canviarColorLletraTeclat(teclat, lletra= 'Q', colorAPintar= "verd")
        val solucioTeclat=arrayOf("\u001B[48;2;60;168;63m\u001B[1m\u001B[38;2;255;255;255m Q ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m W ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m E ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m R ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m T ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Y ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m U ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m I ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m O ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m P ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m A ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m S ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m D ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m F ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m G ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m H ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m J ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m K ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m L ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Ç ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Z ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m X ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m C ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m V ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m B ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m N ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m M ")
        assertArrayEquals(solucioTeclat, teclat2)
    }
    @Test
    fun testLletraGrogaInicialmentVerda(){
        var teclat=arrayOf("\u001B[48;2;60;168;63m\u001B[1m\u001B[38;2;255;255;255m Q ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m W ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m E ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m R ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m T ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Y ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m U ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m I ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m O ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m P ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m A ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m S ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m D ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m F ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m G ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m H ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m J ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m K ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m L ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Ç ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Z ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m X ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m C ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m V ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m B ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m N ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m M ")
        var teclat2= canviarColorLletraTeclat(teclat, lletra= 'Q', colorAPintar= "groc")
        val solucioTeclat=arrayOf("\u001B[48;2;60;168;63m\u001B[1m\u001B[38;2;255;255;255m Q ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m W ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m E ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m R ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m T ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Y ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m U ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m I ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m O ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m P ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m A ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m S ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m D ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m F ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m G ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m H ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m J ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m K ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m L ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Ç ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Z ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m X ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m C ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m V ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m B ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m N ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m M ")
        assertArrayEquals(solucioTeclat, teclat2)
    }
    @Test
    fun testLletraGroga(){
        var teclat=arrayOf("\u001B[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Q ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m W ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m E ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m R ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m T ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Y ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m U ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m I ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m O ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m P ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m A ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m S ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m D ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m F ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m G ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m H ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m J ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m K ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m L ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Ç ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Z ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m X ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m C ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m V ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m B ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m N ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m M ")
        var teclat2= canviarColorLletraTeclat(teclat, lletra= 'Q', colorAPintar= "groc")
        val solucioTeclat=arrayOf("\u001B[48;2;214;154;41m\u001B[1m\u001B[38;2;255;255;255m Q ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m W ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m E ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m R ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m T ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Y ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m U ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m I ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m O ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m P ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m A ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m S ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m D ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m F ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m G ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m H ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m J ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m K ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m L ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Ç ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Z ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m X ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m C ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m V ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m B ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m N ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m M ")
        assertArrayEquals(solucioTeclat, teclat2)
    }
    @Test
    fun testLletraGrisInicialmentGroga(){
        var teclat=arrayOf("\u001B[48;2;214;154;41m\u001B[1m\u001B[38;2;255;255;255m Q ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m W ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m E ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m R ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m T ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Y ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m U ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m I ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m O ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m P ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m A ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m S ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m D ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m F ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m G ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m H ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m J ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m K ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m L ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Ç ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Z ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m X ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m C ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m V ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m B ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m N ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m M ")
        var teclat2= canviarColorLletraTeclat(teclat, lletra= 'Q', colorAPintar= "gris")
        val solucioTeclat=arrayOf("\u001B[48;2;214;154;41m\u001B[1m\u001B[38;2;255;255;255m Q ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m W ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m E ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m R ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m T ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Y ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m U ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m I ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m O ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m P ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m A ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m S ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m D ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m F ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m G ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m H ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m J ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m K ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m L ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Ç ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Z ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m X ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m C ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m V ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m B ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m N ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m M ")
        assertArrayEquals(solucioTeclat, teclat2)
    }
    @Test
    fun testLletraGris(){
        var teclat=arrayOf("\u001B[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Q ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m W ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m E ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m R ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m T ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Y ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m U ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m I ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m O ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m P ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m A ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m S ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m D ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m F ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m G ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m H ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m J ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m K ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m L ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Ç ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Z ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m X ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m C ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m V ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m B ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m N ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m M ")
        var teclat2= canviarColorLletraTeclat(teclat, lletra= 'Q', colorAPintar= "gris")
        val solucioTeclat=arrayOf("\u001B[48;2;120;124;126m\u001B[1m\u001B[38;2;255;255;255m Q ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m W ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m E ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m R ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m T ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Y ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m U ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m I ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m O ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m P ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m A ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m S ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m D ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m F ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m G ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m H ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m J ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m K ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m L ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Ç ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m Z ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m X ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m C ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m V ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m B ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m N ", "\u001b[48;2;211;214;218m\u001B[1m\u001B[38;5;0m M ")
        assertArrayEquals(solucioTeclat, teclat2)
    }
}